<template>
  <a-drawer
    width="70%"
    :visible="visible"
    :title="`${data?.merchantName}时段列表`"
    :body-style="{ paddingBottom: '28px' }"
    @update:visible="updateVisible"
    :confirm-loading="loading"
    :footer="null"
  >
    <ele-pro-table
      ref="tableRef"
      row-key="specValueId"
      :columns="columns"
      :datasource="datasource"
      :customRow="customRow"
      tool-class="ele-toolbar-form"
      class="sys-org-table"
    >
      <template #toolbar>
        <search
          @search="reload"
          :selection="selection"
          @add="openEdit"
          @remove="removeBatch"
          @batchMove="openMove"
        />
      </template>
      <template #bodyCell="{ column, record }">
        <template v-if="column.key === 'isStatus'">
          <a-tag v-if="record.isStatus === 1" color="green">开启</a-tag>
          <a-tag v-if="record.isStatus === 2" color="red">关闭</a-tag>
        </template>
        <template v-if="column.key === 'isFree'">
          <a-tag v-if="record.isFree === 1" color="green">免费</a-tag>
          <a-tag v-if="record.isFree === 2" color="orange">收费</a-tag>
        </template>
        <template v-if="column.key === 'action'">
          <a-space>
            <a @click="moveUp(record)">上移<ArrowUpOutlined /></a>
            <a-divider type="vertical" />
            <a @click="openEdit(record)">编辑</a>
            <a-divider type="vertical" />
            <a-popconfirm
              title="确定要删除此记录吗？"
              @confirm="remove(record)"
            >
              <a class="ele-text-danger">删除</a>
            </a-popconfirm>
          </a-space>
        </template>
      </template>
    </ele-pro-table>
    <!-- 编辑弹窗 -->
    <PeriodEdit
      v-model:visible="showEdit"
      :merchant="data"
      :merchantId="categoryId"
      :data="current"
      @done="reload"
    />
  </a-drawer>
</template>

<script lang="ts" setup>
  import { createVNode, ref, watch } from 'vue';
  import { message, Modal } from 'ant-design-vue';
  import {
    ArrowUpOutlined,
    ExclamationCircleOutlined
  } from '@ant-design/icons-vue';
  import { EleProTable } from 'ele-admin-pro';
  import type {
    DatasourceFunction,
    ColumnItem
  } from 'ele-admin-pro/es/ele-pro-table/types';
  import Search from './components/search.vue';
  import PeriodEdit from './components/periodEdit.vue';
  import {
    pagePeriod,
    removePeriod,
    removeBatchPeriod,
    updatePeriod
  } from '@/api/booking/period';
  import type { Period, PeriodParam } from '@/api/booking/period/model';
  import { Merchant } from '@/api/shop/merchant/model';

  const props = defineProps<{
    // 弹窗是否打开
    visible: boolean;
    // 修改回显的数据
    categoryId?: number | null;
    // 商户信息
    data?: Merchant;
  }>();

  const emit = defineEmits<{
    (e: 'done'): void;
    (e: 'update:visible', visible: boolean): void;
  }>();

  /* 更新visible */
  const updateVisible = (value: boolean) => {
    emit('update:visible', value);
  };

  // 表格实例
  const tableRef = ref<InstanceType<typeof EleProTable> | null>(null);
  // 表格选中数据
  const selection = ref<Period[]>([]);
  // 当前编辑数据
  const current = ref<Period | null>(null);
  // 是否显示编辑弹窗
  const showEdit = ref(false);
  // 是否显示批量移动弹窗
  const showMove = ref(false);
  // 加载状态
  const loading = ref(true);

  // 表格数据源
  const datasource: DatasourceFunction = ({
    page,
    limit,
    where,
    orders,
    filters
  }) => {
    if (filters) {
      where.status = filters.status;
    }
    where.merchantId = props.categoryId;
    return pagePeriod({
      ...where,
      ...orders,
      page,
      limit
    });
  };

  // 表格列配置
  const columns = ref<ColumnItem[]>([
    {
      title: 'ID',
      dataIndex: 'periodId',
      key: 'periodId',
      width: 90
    },
    {
      title: '时段',
      dataIndex: 'timePeriod',
      key: 'timePeriod',
      align: 'center'
    },
    {
      title: '价格',
      dataIndex: 'price',
      key: 'price',
      align: 'center'
    },
    {
      title: '半场价格',
      dataIndex: 'halfPrice',
      key: 'halfPrice',
      align: 'center'
    },
    {
      title: '儿童价',
      dataIndex: 'childrenPrice',
      key: 'childrenPrice',
      align: 'center'
    },
    {
      title: '时间段状态',
      dataIndex: 'isStatus',
      key: 'isStatus',
      align: 'center'
    },
    {
      title: '是否免费',
      dataIndex: 'isFree',
      key: 'isFree',
      align: 'center'
    },
    {
      title: '排序',
      dataIndex: 'sortNumber',
      key: 'sortNumber',
      align: 'center'
    },
    {
      title: '操作',
      key: 'action',
      width: 180,
      fixed: 'right',
      align: 'center',
      hideInSetting: true
    }
  ]);

  /* 搜索 */
  const reload = (where?: PeriodParam) => {
    selection.value = [];
    tableRef?.value?.reload({ where: where });
  };

  /* 打开编辑弹窗 */
  const openEdit = (row?: Period) => {
    current.value = row ?? null;
    // if (props.data?.specId) {
    //   specId.value = props.data?.specId;
    // }
    showEdit.value = true;
  };

  /* 打开批量移动弹窗 */
  const openMove = () => {
    showMove.value = true;
  };

  /* 删除单个 */
  const remove = (row: Period) => {
    const hide = message.loading('请求中..', 0);
    removePeriod(row.periodId)
      .then((msg) => {
        hide();
        message.success(msg);
        reload();
      })
      .catch((e) => {
        hide();
        message.error(e.message);
      });
  };

  /* 批量删除 */
  const removeBatch = () => {
    if (!selection.value.length) {
      message.error('请至少选择一条数据');
      return;
    }
    Modal.confirm({
      title: '提示',
      content: '确定要删除选中的记录吗?',
      icon: createVNode(ExclamationCircleOutlined),
      maskClosable: true,
      onOk: () => {
        const hide = message.loading('请求中..', 0);
        removeBatchPeriod(selection.value.map((d) => d.periodId))
          .then((msg) => {
            hide();
            message.success(msg);
            reload();
          })
          .catch((e) => {
            hide();
            message.error(e.message);
          });
      }
    });
  };

  // 上移
  const moveUp = (row?: Period) => {
    updatePeriod({
      periodId: row?.periodId,
      sortNumber: Number(row?.sortNumber) - 1
    }).then((msg) => {
      message.success(msg);
      reload();
    });
  };

  /* 自定义行属性 */
  const customRow = (record: Period) => {
    return {
      // 行点击事件
      onClick: () => {
        // console.log(record);
      },
      // 行双击事件
      onDblclick: () => {
        openEdit(record);
      }
    };
  };

  watch(
    () => props.categoryId,
    (categoryId) => {
      if (categoryId) {
        reload();
      }
    }
  );
</script>

<script lang="ts">
  export default {
    name: 'Period'
  };
</script>

<style lang="less" scoped></style>
